<?php
class Cart extends Controller{
    public function index()

	{

        /******** start header code ********/
		if($this->loadHelper("UserHelper")->check_user_login())
		{
			// get user id from session
			$user_id = $this->loadSession()->getSession("user_id");
			// get user data for header
			$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
			if($dataView['userData'] == NULL)

			{
				$this->redirect("error","index");
				exit();
			}
		}
        $dataView['current'] = "cart";
		/******* end header code *******/
//       / var_dump($_SESSION);
        if(isset($_SESSION['cart']) && is_array($_SESSION['cart']))
        {
            // get data
            foreach($_SESSION['cart'] as $key=>$value)
            {
                // get product data
                $dataView['products'][$key] = $this->loadModel("OfferModel")->retriveDataById("id",$key);
                $dataView['productsLang'][$key] = $this->loadModel("OfferEnModel")->retriveDataById("id_offer",$key);
                $dataView['quantities'][$key] = $value['quantity'];
                $dataView['prices'][$key] = $value['price'];
            }
        }

        // set page title
		$dataView['title'] = "Shatably | Cart";
		 // global Template Config
        global $TEMPLATE_FRONT_END ;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH."cart_view";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END,$dataView)->render();

	}
    public function sendOrder()

	{
        ob_start();
        /******** start header code ********/
		if($this->loadHelper("UserHelper")->check_user_login())
		{
			// get user id from session
			$user_id = $this->loadSession()->getSession("user_id");
			// get user data for header
			$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
			if($dataView['userData'] == NULL)

			{
				$this->redirect("error","index");
				exit();
			}
		}else{
		    $url = BASE_URL."cart/sendOrder";
		    $this->loadSession(array("url"=>$url))->setSession();
            $this->redirect("login","index");
            exit();
        }
        $dataView['current'] = "cart";
		/******* end header code *******/
//       / var_dump($_SESSION);
        if(isset($_SESSION['cart']) && is_array($_SESSION['cart']))
        {
            // get data
            foreach($_SESSION['cart'] as $key=>$value)
            {
                // get product data
                $dataView['products'][$key] = $this->loadModel("OfferModel")->retriveDataById("id",$key);
                $dataView['productsLang'][$key] = $this->loadModel("OfferEnModel")->retriveDataById("id_offer",$key);
                $dataView['quantities'][$key] = $value['quantity'];
                $dataView['prices'][$key] = $value['price'];
            }
        }
        // get user addresses
        $dataView['addresses'] = $this->loadModel("UserAddressModel")->retrieveAllData("WHERE `id_user` =? AND `status` =? AND `deleted` =?", array($user_id, 1, 1));
        // get addresses data
        if (is_array($dataView['addresses'])) {
            foreach ($dataView['addresses'] as $key => $value) {
                $dataView['addresses_cities'][$key] = $this->loadModel("CityEnModel")->retriveDataById("id_city", $value['id_city']);
            }
        }
        // get all PaymentWays
        $dataView['paymentWays'] = $this->loadModel("PaymentWayModel")->retrieveAllData("WHERE `status` = ? AND `deleted` =?",array(1,1));
        if(is_array($dataView['paymentWays']))
        {
            foreach($dataView['paymentWays'] as $key=>$value)
            {
                // get Lang Data
                $dataView['paymentWaysLang'][$key] = $this->loadModel("PaymentWayEnModel")->retriveDataById("id_payment",$value['id']);
            }
        }
        // get all citites
        $dataView['cities'] = $this->loadModel("CityArModel")->retrieveAllData("WHERE `status` =? AND `deleted` =? ORDER BY `name` DESC", array( 1, 1));
        
        // set page title
		$dataView['title'] = "Shatably | Cart";
		 // global Template Config
        global $TEMPLATE_FRONT_END ;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH."cart_send_order";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END,$dataView)->render();

	}
    public function addAddress()
    {
        session_start();
        if (isset($_POST['action']) && $_POST['action'] == "addAddress") {
                                // preparing validation array
         $validationArray = array(

                                    "id_city" => array(
                                        "value" => $this->loadSecurity($_POST['id_city'])->clear(),
                                        "errorName" => "City",
                                        "rules" => "required|number"
                                    ),
                                    "region_name" => array(
                                        "value" => $this->loadSecurity($_POST['region_name'])->clear(),
                                        "errorName" => "Region",
                                        "rules" => "required|min-length[3]"
                                    ),
                                    "street" => array(
                                        "value" => $this->loadSecurity($_POST['street'])->clear(),
                                        "errorName" => "Street Name",
                                        "rules" => "required"
                                    ),
                                    "building_number" => array(
                                        "value" => $this->loadSecurity($_POST['building_number'])->clear(),
                                        "errorName" => "Building Number",
                                    ),
                                    "floar_number" => array(
                                        "value" => $this->loadSecurity($_POST['floar_number'])->clear(),
                                        "errorName" => "Floor Number",
                                        "rules" => "required"
                                    ),
            );

            // load validation classs and pass validation data
            $dataValid = $this->loadValidation($validationArray)->formValidate();
            // check if the data is ok
            if (is_array($dataValid) && array_key_exists("success", $dataValid)) {
                $user_id = $this->loadSession()->getSession("user_id");
                // prepare data
                $dataValid['success']['id_user'] = $user_id;
                $dataValid['success']['created'] = time();

                $add = $this->loadModel("UserAddressModel", $dataValid['success'])->add();
                if (FALSE !== $add) {
                    $city = $this->loadModel("CityArModel")->retriveDataById("id_city", $dataValid['success']['id_city']);
                    $response['status'] = "success";
                    $response['id'] = $add;
                    $response['city'] = $city;
                    $response['region'] = $dataValid['success']['region_name'];
                    $response['street'] = $dataValid['success']['street'];
                    $response['building_number'] = $dataValid['success']['building_number'];
                    $response['floar_number'] = $dataValid['success']['floar_number'];
                    $response['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Address Successfully Added . </div>';
                    echo $this->loadAjax()->DataToJson($response);
                    exit;  
                } else {
                    $response['status'] = "faild";
                    $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Address.</div>';
                    echo $this->loadAjax()->DataToJson($response);
                    exit;
                }
            } else {
                $response['status'] = "faild";
                $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                echo $this->loadAjax()->DataToJson($response);
                exit;
            }
        }
    }
    public function makeOrder()
    {
        session_start();
        if(isset($_POST['action']) && $_POST['action'] = "makeOrder")
        {

            // preparing validation array
            $validationArray = array(
                                        "id_address"=>array(
                                                         "value"=>$this->loadSecurity($_POST['id_address'])->clear(),
                                                         "errorName"=>"Address",
                                                         "rules"=>"required|number"
                                                         ),
                                        "id_payment_way"=>array(
                                                         "value"=>$this->loadSecurity($_POST['id_payment_way'])->clear(),
                                                         "errorName"=>"Payment Way",
                                                         "rules"=>"required|number"
                                                         ),
                                        "delivery_time"=>array(
                                                         "value"=>$this->loadSecurity($_POST['deliveryCustomDate'])->clear(),
                                                         "errorName"=>"Delivery Time",
                                                         "rules"=>"required|number"
                                                         ),
                                        "deliveryDate"=>array(
                                                         "value"=>$this->loadSecurity($_POST['deliveryDate'])->clear(),
                                                         "errorName"=>"delivery Date",
                                                         ),
                                        "deliveryTimeFrom"=>array(
                                                         "value"=>$this->loadSecurity($_POST['deliveryTimeFrom'])->clear(),
                                                         "errorName"=>"delivery Time From",
                                                         ),
                                        "deliveryTimeTo"=>array(
                                                         "value"=>$this->loadSecurity($_POST['deliveryTimeTo'])->clear(),
                                                         "errorName"=>"delivery Time To",
                                                         ),
                                        

                              );
            // load validation classs and pass validation data
            $dataValid = $this->loadValidation($validationArray)->formValidate();
            // check if the data is ok
            if(is_array($dataValid) && array_key_exists("success",$dataValid))
            {
                
                if($dataValid['success']['delivery_time'] == 2)
                {
                    if(empty($dataValid['success']['deliveryDate']) || empty($dataValid['success']['deliveryTimeFrom'])  || empty($dataValid['success']['deliveryTimeTo']))
                    {
                      $response['status'] = "faild";
                      $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>Please Add Delivery Time</div>';
                      echo $this->loadAjax()->DataToJson($response);
                      exit;           
                    }
                }
                
                // get user id
                $user_id = $this->loadSession()->getSession("user_id");   
                if($user_id != NULL)
                {
                    if(isset($_SESSION['cart']))
                    { 
                        $sessionData = $_SESSION['cart'];

                        // get cart total price
                        $cartPrice = 0;
                        $dataView['cartData'] = isset($_SESSION['cart']) ? $_SESSION['cart'] : NULL;
                        if(is_array($dataView['cartData']))
                        {
                            foreach($dataView['cartData'] as $key=>$value)
                            {
                                $cartPrice += ($value['quantity'] * $value['price']);
                            }
                        }
                        // get governate to get shipping amount
                        $address = $this->loadModel("UserAddressModel")->retrieveAllData("WHERE `id` =? AND `id_user` =? AND `status` =? AND `deleted` =?", array($dataValid['success']['id_address'],$user_id, 1, 1));
                        if(is_array($address))
                        {
                          // get city
                            $city =  $this->loadModel("CityModel")->retriveDataById("id",$address[0]['id_city']);
                            if(is_array($city))
                            {
                                $customerOrderOrder['shipping'] = $city['shipping'];
                                $customerOrderOrder['id_customer'] = $user_id;
                                $customerOrderOrder['created_by'] = $user_id;
                                $customerOrderOrder['last_updated_by'] = $user_id;
                                $customerOrderOrder['total_price'] = $cartPrice;
                                $customerOrderOrder['id_address'] = $dataValid['success']['id_address'];
                                $customerOrderOrder['delivery_time'] = (int)$dataValid['success']['delivery_time'];
                                $customerOrderOrder['id_payment_way'] = $dataValid['success']['id_payment_way'];
                                $customerOrderOrder['total_with_shipping'] = ($customerOrderOrder['total_price'] + $customerOrderOrder['shipping']);
                                $customerOrderOrder['created'] = time();
                                // add request
                                $add = $this->loadModel("CustomerOrderModel",$customerOrderOrder)->add();
                                if(FALSE !== $add)
                                {
                                    // add request products
                                    foreach($sessionData as $key=>$value)
                                    {
                                        // prepare data
                                        $requestProducts['id_order'] = $add;
                                        $requestProducts['id_product'] = $key;
                                        $requestProducts['quantity'] = $value['quantity'];
                                        $requestProducts['price_per_item'] = $value['price'];
                                        $requestProducts['total_price'] = ($value['price'] * $value['quantity']) ;
                                        $requestProducts['created'] = time();
                                        $requestProducts['created_by'] = $user_id;
                                        $requestProducts['last_updated_by'] = $user_id;
                                        $this->loadModel("CustomerOrderModelDetails",$requestProducts)->add();
                                        // update product  report
                                        $updateProductReport = $this->loadModel("OfferReportModel")->retrieveDataByQuery("UPDATE `offer_report` SET `total_sales` = `total_sales` + ? WHERE `id_offer` = ?",array(1,$key));
                                    }
                                    if($dataValid['success']['delivery_time'] == 2)
                                    {
                                        $orderDeliveryTime['id_order'] = $add;
                                        $orderDeliveryTime['delivery_date'] = $dataValid['success']['deliveryDate'];
                                        $orderDeliveryTime['delivery_time_from'] = $dataValid['success']['deliveryTimeFrom'];
                                        $orderDeliveryTime['delivery_time_to'] = $dataValid['success']['deliveryTimeTo'];
                                        $orderDeliveryTime['created_by'] = $user_id;
                                        $orderDeliveryTime['last_updated_by'] = $user_id;
                                        $orderDeliveryTime['created'] = time();
                                        $this->loadModel("OrderDeliveryTimeModel",$orderDeliveryTime)->add();
                                    }
                                    // prepare data
                                    $orderStatusDataModel['id_order'] = $add;
                                    $orderStatusDataModel['id_order_status'] = 1;
                                    $orderStatusDataModel['created'] = time();
                                    $orderStatusDataModel['created_by'] = $user_id;
                                    $orderStatusDataModel['last_updated_by'] = $user_id;
                                    $this->loadModel("TrackingOrderStatus",$orderStatusDataModel)->add();
                                    unset($_SESSION['cart']);
                                    $response['status'] = "success";
                                    $response['id'] = $add;
                                    $response['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your order has been successfully sent</div>';
                                    echo $this->loadAjax()->DataToJson($response);
                                    exit;  
                                }else{
                                    $response['status'] = "faild";
                                    $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Please Try Again Later</div>';
                                    echo $this->loadAjax()->DataToJson($response);
                                    exit;
                                } 
                            }else{
                                $response['status'] = "faild";
                                $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>City Error</div>';
                                echo $this->loadAjax()->DataToJson($response);
                                exit;
                            }

                        }else{
                            $response['status'] = "faild";
                            $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>City Error</div>';
                            echo $this->loadAjax()->DataToJson($response);
                            exit;
                        }
                    }else{
                        $response['status'] = "faild";
                        $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> فشل ! </strong>لا توجد منتجات في السلة</div>';
                        echo $this->loadAjax()->DataToJson($response);
                        exit;
                    }
                        
                }else{
                    $response['status'] = "faild";
                    $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Customer Data Error</div>';
                    echo $this->loadAjax()->DataToJson($response);
                    exit;
                }
            }else{
                $response['status'] = "faild";
                $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                echo $this->loadAjax()->DataToJson($response);
                exit;
            }
        }
    }
    public function getShipping()
    {
        session_start();
        if(isset($_POST['action'],$_POST['id_address']) && $_POST['action'] == "getShipping")
        {

            // get User id
            $id = (int)$_POST['id_address'];
            if($id == 0)
            {
                echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                exit;
            }else{
                // get  address
                $user_id = $this->loadSession()->getSession("user_id");
                $address = $this->loadModel("UserAddressModel")->retrieveAllData("WHERE `id` =? AND `id_user` =? AND `status` =? AND `deleted` =?", array($id,$user_id, 1, 1));
                if(is_array($address))
                {
                  // get city
                    $city =  $this->loadModel("CityModel")->retriveDataById("id",$address[0]['id_city']);
                    if(is_array($city))
                    {
                        $response['status'] = "success";
                        $response['shipping'] = $city['shipping'];
                        echo $this->loadAjax()->DataToJson($response);
                        exit;
                    }else{
                        echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                        exit;
                    }
                 
                }else{
                    echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                    exit;
                }
            }
        }
    }
    
}
?>