<?php
class Product extends Controller{
    
    public function view()
	{

        /******** start header code ********/
		if($this->loadHelper("UserHelper")->check_user_login())
		{
			// get user id from session
			$user_id = $this->loadSession()->getSession("user_id");
			// get user data for header
			$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
			if($dataView['userData'] == NULL)

			{
				$this->redirect("error","index");
				exit();
			}
		}
        $dataView['current'] = "product";
		/******* end header code *******/
		// get id from url
        $id = (int)$this->loadRoute()->getSegment(2);
        if ($id == 0) {
            $this->redirect("error", "index");
            exit();
        }
        // get Offer data
        $dataView['offer'] = $this->loadModel("OfferModel")->retrieveAllData("WHERE `id` =? AND `approved` =? AND `status` =?  AND `deleted` =?", array($id,1,1,1));

        if (!is_array($dataView['offer'])) {
            $this->redirect("error", "index");
            exit();
        }
        $dataView['offer'] = array_shift($dataView['offer']);
        $updateProductReport = $this->loadModel("OfferReportModel")->retrieveDataByQuery("UPDATE `offer_report` SET `total_views` = `total_views` + ? WHERE `id_offer` = ?",array(1,$id));
        // offer lang data
        $dataView['offerLang'] = $this->loadModel("OfferEnModel")->retriveDataById("id_offer", $id);
        // get offer summery
        $dataView['offerSummery'] = $this->loadModel("OfferReportModel")->retriveDataById("id_offer", $id);
        // get offer images
        $dataView['offerImages'] = $this->loadModel("OfferImagesModel")->retrieveAllData("WHERE `id_offer` =? AND `status` =? AND `deleted` = ?", array($id, 1, 1));

        $dataView['mainCategoryLang'] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category", $dataView['offer']['id_category']);
        if($dataView['offer']['id_sub_category'] != NULL)
        {
            $dataView['subCategoryLang'] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category", $dataView['offer']['id_sub_category']);
        }
        // get offer items
        $dataView['offerItems'] = $this->loadModel("OfferAttributesModel")->retrieveAllData("WHERE `id_offer` =? AND `status` =? AND `deleted` = ?", array($id, 1, 1));
        if (is_array($dataView['offerItems'])) {
            foreach ($dataView['offerItems'] as $key => $value) {
                $dataView['itemsLang'][$key] = $this->loadModel("CategoryAttributesEnModel")->retriveDataById("id_category_attributes", $value['id_attribute']);
            }
        }
        // get offer price
        $dataView['offerPrice'] = $this->loadModel("OfferDefaultPriceModel")->retrieveAllData("WHERE `id_offer` =? AND `status` =? AND `deleted` = ? ORDER BY `id` DESC LIMIT 1", array($id, 1, 1));
        if (is_array($dataView['offerPrice'])) {
            $dataView['offerDefaultPrice'] = array_shift($dataView['offerPrice']);
        }
        //get 5product in same category
        $dataView['productInSameCategory'] = $this->loadModel("OfferModel")->retrieveAllData("WHERE `approved` =? AND  `deleted` =?  AND `status`=? AND `id`!=? AND `id_category`=? OR `id_sub_category` =? Order By Rand() Limit 5", array(1,1, 1, $id,$dataView['offer']['id_category'],$dataView['offer']['id_category']));
        if (is_array($dataView['productInSameCategory'])) 
        {
            foreach ($dataView['productInSameCategory'] as $key => $value)
            {
                $dataView['offersDataLang'][$key] = $this->loadModel("OfferEnModel")->retriveDataById("id_offer", $value['id']);
                $dataView['latestPrice'][$key] = $this->loadModel("OfferDefaultPriceModel")->retrieveAllData("WHERE `id_offer` =? AND `deleted`=? ORDER BY id Desc LIMIT 1", array($value['id'], 1));
                if (is_array($dataView['latestPrice'][$key])) {
                    $dataView['latestPrice'][$key] = array_shift($dataView['latestPrice'][$key]);
                }
            }
        }
        //get 5 product no in this category
        $dataView['productInDifferantCategory'] = $this->loadModel("OfferModel")->retrieveAllData("WHERE `approved` =?  AND `deleted` =?  AND `status`=? AND `id`!=? AND `id_category`!=? Order By Rand() Limit 5", array(1,1, 1, $id, $dataView['offer']['id_category']));
        if (is_array($dataView['productInDifferantCategory'])) {
            foreach ($dataView['productInDifferantCategory'] as $key => $value){
                $dataView['productInDifferantCategoryLang'][$key] = $this->loadModel("OfferEnModel")->retriveDataById("id_offer", $value['id']);
                $dataView['latestPriceDifferantCategory'][$key] = $this->loadModel("OfferDefaultPriceModel")->retrieveAllData("WHERE `id_offer` =? AND `deleted`=? ORDER BY id Desc LIMIT 1", array($value['id'], 1));
                if (is_array($dataView['latestPriceDifferantCategory'][$key])) {
                    $dataView['latestPriceDifferantCategory'][$key] = array_shift($dataView['latestPriceDifferantCategory'][$key]);
                }
            }
        }
        
        //get product cmoomments
        $dataView['comments'] = $this->loadModel("OfferCommentsModel")->retrieveAllData("WHERE `id_offer`=? AND `status`=? And `deleted`=? ", array($id, 1, 1));
        if (is_array($dataView['comments'])) 
        {
            foreach ($dataView['comments'] as $key => $value)
            {
                $dataView['commentsUsers'][$key] = $this->loadModel("UserModel")->retriveDataById('id', $value['created_by']);
            }
        }
        
        // set page title
		$dataView['title'] = "Shatably | ".$dataView['offerLang']['title'];
		 // global Template Config
        global $TEMPLATE_FRONT_END ;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH."product_view";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END,$dataView)->render();

	}
    public function addRate()
    {
        session_start();
        if(isset($_POST['offer_id'],$_POST['action']) && $_POST['action'] = "addRate")
        {
            // preparing validation array
            $validationArray = array(
                                        "id_offer"=>array(
                                                         "value"=>$this->loadSecurity($_POST['offer_id'])->clear(),
                                                         "errorName"=>"Offer Id",
                                                         "rules"=>"required|number"
                                                      ),
                                    "rate"=>array(
                                                         "value"=>$this->loadSecurity($_POST['rate'])->clear(),
                                                         "errorName"=>"Rate",
                                                         "rules"=>"required|number"
                                                      ),
                              );
            // load validation classs and pass validation data
            $dataValid = $this->loadValidation($validationArray)->formValidate();
            // check if the data is ok
            if(is_array($dataValid) && array_key_exists("success",$dataValid))
            {
                // get user id
                $user_id = $this->loadSession()->getSession("user_id");  
                if($user_id != NULL)
                {
                    $checkRate = $this->loadModel("UserRateOfferModel")->retrieveAllData("WHERE `id_user` = ? AND `id_offer` =? AND `status` =? AND `deleted` =?",array($user_id,$dataValid['success']['id_offer'],1,1));
                    // check if user rate offer before
                    if(!is_array($checkRate))                                                                       
                    {
                        // add rate
                        $rateModel['id_offer'] = $dataValid['success']['id_offer'];
                        $rateModel['id_user'] = $user_id;
                        $rateModel['rate'] = $dataValid['success']['rate'];
                        $rateModel['created'] = time();
                        $addRate = $this->loadModel("UserRateOfferModel",$rateModel)->add();
                        // update driver summery
                        if($dataValid['success']['rate'] == 1)
                        {
                           $updateOfferSummery = $this->loadModel("OfferReportModel")->retrieveDataByQuery("UPDATE `offer_report` SET `total_users_rates` = `total_users_rates` + 1 , `star1_count` = `star1_count` + 1  WHERE `id_offer` =?",array($rateModel['id_offer'])); 
                        }elseif($dataValid['success']['rate'] == 2){
                           $updateOfferSummery = $this->loadModel("OfferReportModel")->retrieveDataByQuery("UPDATE `offer_report` SET `total_users_rates` = `total_users_rates` + 1 , `star2_count` = `star2_count` + 1  WHERE `id_offer` =?",array($rateModel['id_offer'])); 
                        }elseif($dataValid['success']['rate'] == 3){
                           $updateOfferSummery = $this->loadModel("OfferReportModel")->retrieveDataByQuery("UPDATE `offer_report` SET `total_users_rates` = `total_users_rates` + 1 , `star3_count` = `star3_count` + 1  WHERE `id_offer` =?",array($rateModel['id_offer'])); 
                        } elseif($dataValid['success']['rate'] == 4){
                           $updateOfferSummery = $this->loadModel("OfferReportModel")->retrieveDataByQuery("UPDATE `offer_report` SET `total_users_rates` = `total_users_rates` + 1 , `star4_count` = `star4_count` + 1  WHERE `id_offer` =?",array($rateModel['id_offer'])); 
                        }elseif($dataValid['success']['rate'] == 5){
                           $updateOfferSummery = $this->loadModel("OfferReportModel")->retrieveDataByQuery("UPDATE `offer_report` SET `total_users_rates` = `total_users_rates` + 1 , `star5_count` = `star5_count` + 1  WHERE `id_offer` =?",array($rateModel['id_offer'])); 
                        }
                        $rate = $this->loadHelper("OfferHelper")->calculateOfferRating($rateModel['id_offer']);
                        // update rate
                        $updateRate = $this->loadModel("OfferReportModel",array("rating"=>$rate))->updateData("id_offer",$rateModel['id_offer']);

                        if(FALSE !== $addRate && FALSE !== $updateOfferSummery && FALSE !== $updateRate)
                        {
                            $response['status'] = "success";
                            $response['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Rate Successfully Added Please Wait... </div>';
                            echo $this->loadAjax()->DataToJson($response);
                            exit;
                        }else{
                            $response['status'] = "faild";
                            $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Please Try Again</div>';
                            echo $this->loadAjax()->DataToJson($response);
                            exit;
                        }
                    }else{
                        // update user old rate
                        $updateOldRate = $this->loadModel("UserRateOfferModel",array("rate"=>$dataValid['success']['rate']))->updateByCondition("WHERE `id_offer` =? AND `id_user` =?",array($dataValid['success']['id_offer'],$user_id));
                        // update stars count 
                        $updateStarsCount = $this->loadModel("OfferReportModel")->retrieveDataByQuery("UPDATE `offer_report` SET  `star".$checkRate[0]['rate']."_count` = `star".$checkRate[0]['rate']."_count` - 1 , `star".$dataValid['success']['rate']."_count` = `star".$dataValid['success']['rate']."_count` + 1 WHERE `id_offer` =?",array($dataValid['success']['id_offer']));
                        // calculate offer rate
                        $rate = $this->loadHelper("OfferHelper")->calculateOfferRating($dataValid['success']['id_offer']);
                        // update rate
                        $updateRate = $this->loadModel("OfferReportModel",array("rating"=>$rate))->updateData("id_offer",$dataValid['success']['id_offer']);
                        if(FALSE !== $updateOldRate && FALSE !== $updateStarsCount && FALSE !== $updateRate)
                        {
                            $response['status'] = "success";
                            $response['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Rate Successfully Added Please Wait... </div>';
                            echo $this->loadAjax()->DataToJson($response);
                            exit;
                        }else{
                            $response['status'] = "faild";
                            $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Please Try Again</div>';
                            echo $this->loadAjax()->DataToJson($response);
                            exit;
                        }

                    }
                }else{
                    $response['status'] = "faild";
                    $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Please Login For Rate Products</div>';
                    echo $this->loadAjax()->DataToJson($response);
                    exit;
                }
            }else{
                $response['status'] = "faild";
                $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                echo $this->loadAjax()->DataToJson($response);
                exit;
            }
        }
    }
    public function add_offer_comment()
    {
        session_start();
        if(isset($_POST['comment_offer_id'],$_POST['action']) && $_POST['action'] = "addComment")
        {
            // preparing validation array
            $validationArray = array(
                                        "id_offer"=>array(
                                                         "value"=>$this->loadSecurity($_POST['comment_offer_id'])->clear(),
                                                         "errorName"=>"Offer Id",
                                                         "rules"=>"required|number"
                                                      ),
                                    "comment"=>array(
                                                         "value"=>$this->loadSecurity($_POST['comment'])->clear(),
                                                         "errorName"=>"Comment",
                                                         "rules"=>"required|min-length[3]"
                                                      ),
                              );
            // load validation classs and pass validation data
            $dataValid = $this->loadValidation($validationArray)->formValidate();
            // check if the data is ok
            if(is_array($dataValid) && array_key_exists("success",$dataValid))
            {
                // get user id
                $user_id = $this->loadSession()->getSession("user_id");  
                if($user_id != NULL)
                {
                    $dataValid['success']['created_by'] = $user_id;
                    $dataValid['success']['last_updated_by'] = $user_id;
                    $dataValid['success']['created'] = time();
                    if(FALSE !== $this->loadModel("OfferCommentsModel",$dataValid['success'])->add())
                    {
                        $response['status'] = "success";
                        $response['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong>Your Comment Successfully Added (Your Comment Will Appear After Approved)</div>';
                        echo $this->loadAjax()->DataToJson($response);
                        exit;   
                    }else{
                        $response['status'] = "faild";
                        $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Please Try Again. </div>';
                        echo $this->loadAjax()->DataToJson($response);
                        exit;
                    }
                }else{
                    $response['status'] = "faild";
                    $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Please Login For Add Comment .</div>';
                    echo $this->loadAjax()->DataToJson($response);
                    exit;
                }
            }else{
                $response['status'] = "faild";
                $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                echo $this->loadAjax()->DataToJson($response);
                exit;
            }
        }
    }
    public function add_offer_to_cart()
    {
        session_start();
        if(isset($_POST['offer_id'],$_POST['action']) && $_POST['action'] = "addToCart")
        {
            // preparing validation array
            $validationArray = array(
                                        "id_offer"=>array(
                                                         "value"=>$this->loadSecurity($_POST['offer_id'])->clear(),
                                                         "errorName"=>"Id Product",
                                                         "rules"=>"required|number"
                                                         )
                              );
            // load validation classs and pass validation data
            $dataValid = $this->loadValidation($validationArray)->formValidate();
            // check if the data is ok
            if(is_array($dataValid) && array_key_exists("success",$dataValid))
            {
                $id_offer = (int)$dataValid['success']['id_offer'];
                // get offer data
                $offer = $this->loadModel("OfferModel")->retrieveAllData("WHERE `id` =? AND `status` =? AND `deleted` =?",array($id_offer,1,1));
                if(is_array($offer))
                {
                    $offer = array_shift($offer);
                    $offerPrice	= $this->loadModel("OfferDefaultPriceModel")->retrieveAllData("WHERE `id_offer` =? AND `deleted`=? ORDER BY id DESC LIMIT 1",array($id_offer,1));
                    if(is_array($offerPrice))
                    {
                        $offerPrice = array_shift($offerPrice);
                    }
                    if(isset($_SESSION['cart'][$id_offer]))
                    { 
                        $_SESSION['cart'][$id_offer]['quantity']++; 
                    }else{
                        $_SESSION['cart'][$id_offer] = array(
                                                            "quantity" => 1,
                                                            "price" => $offerPrice['price_after_discount']
                                                            );
                    }
                    $response['status'] = "success";
                    $response['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> </strong> Product Added To Your Cart.</div>';
                    echo $this->loadAjax()->DataToJson($response);
                    exit;
                }else{
                    $response['status'] = "faild";
                    $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> </strong> Offer Id Error</div>';
                    echo $this->loadAjax()->DataToJson($response);
                    exit;
                }
            }else{
                $response['status'] = "faild";
                $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i></strong>'.$dataValid.'</div>';
                echo $this->loadAjax()->DataToJson($response);
                exit;
            }
        }
    }
    public function add_offer_and_quantity_to_cart()
    {
        session_start();
        if(isset($_POST['offer_id'],$_POST['quantity'],$_POST['action']) && $_POST['action'] = "addToCart")
        {
            // preparing validation array
            $validationArray = array(
                                        "id_offer"=>array(
                                                         "value"=>$this->loadSecurity($_POST['offer_id'])->clear(),
                                                         "errorName"=>"Product Id",
                                                         "rules"=>"required|number"
                                                         ),
                                        "quantity"=>array(
                                                         "value"=>$this->loadSecurity($_POST['quantity'])->clear(),
                                                         "errorName"=>"quantity",
                                                         "rules"=>"required|number"
                                                         ),
                              );
            // load validation classs and pass validation data
            $dataValid = $this->loadValidation($validationArray)->formValidate();
            // check if the data is ok
            if(is_array($dataValid) && array_key_exists("success",$dataValid))
            {
                $id_offer = (int)$dataValid['success']['id_offer'];
                // get offer data
                $offer = $this->loadModel("OfferModel")->retrieveAllData("WHERE `id` =? AND `status` =? AND `deleted` =?",array($id_offer,1,1));
                if(is_array($offer))
                {
                    $offer = array_shift($offer);
                    $offerPrice	= $this->loadModel("OfferDefaultPriceModel")->retrieveAllData("WHERE `id_offer` =? AND `deleted`=? ORDER BY id DESC LIMIT 1",array($id_offer,1));
                    if(is_array($offerPrice))
                    {
                        $offerPrice = array_shift($offerPrice);
                    }
                    if(isset($_SESSION['cart'][$id_offer]))
                    { 
                        $_SESSION['cart'][$id_offer]['quantity']+= $dataValid['success']['quantity']; 
                    }else{
                        $_SESSION['cart'][$id_offer] = array(
                                                            "quantity" => $dataValid['success']['quantity'],
                                                            "price" => $offerPrice['price_after_discount']
                                                            );
                    }
                    $response['status'] = "success";
                    $response['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> </strong> Product Added To Your Cart.</div>';
                    echo $this->loadAjax()->DataToJson($response);
                    exit;
                }else{
                    $response['status'] = "faild";
                    $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> </strong> Offer Id Error</div>';
                    echo $this->loadAjax()->DataToJson($response);
                    exit;
                }
            }else{
                $response['status'] = "faild";
                $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i></strong>'.$dataValid.'</div>';
                echo $this->loadAjax()->DataToJson($response);
                exit;
            }
        }
    }
    public function changeProductQuantityOnCart()
    {
        session_start();
        if(isset($_POST['offer_id'],$_POST['action']) && $_POST['action'] = "changeProductQuantityOnCart")
        {
            // preparing validation array
            $validationArray = array(
                                        "quantity"=>array(
                                                         "value"=>$this->loadSecurity($_POST['quantity'])->clear(),
                                                         "errorName"=>"Quantity",
                                                         "rules"=>"required|number"
                                                         ),
                                        "id_offer"=>array(
                                                         "value"=>$this->loadSecurity($_POST['offer_id'])->clear(),
                                                         "errorName"=>"Id Prodcut",
                                                         "rules"=>"required|number"
                                                         )
                              );
            // load validation classs and pass validation data
            $dataValid = $this->loadValidation($validationArray)->formValidate();
            // check if the data is ok
            if(is_array($dataValid) && array_key_exists("success",$dataValid))
            {
                // get user id
                $user_id = $this->loadSession()->getSession("user_id");   

                    $id_offer = (int)$dataValid['success']['id_offer'];
                    // get offer data
                    $offer = $this->loadModel("OfferModel")->retrieveAllData("WHERE `id` =? AND `status` =? AND `deleted` =?",array($id_offer,1,1));
                    if(is_array($offer))
                    {
                        $offer = array_shift($offer);
                        if(isset($_SESSION['cart'][$id_offer]))
                        { 
                            $_SESSION['cart'][$id_offer]['quantity'] = (int)$dataValid['success']['quantity']; 
                            $response['status'] = "success";
                            $response['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Cart Successfully Updated. </div>';
                            echo $this->loadAjax()->DataToJson($response);
                            exit;
                        }else{
                            $response['status'] = "faild";
                            $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Offer Id Error</div>';
                            echo $this->loadAjax()->DataToJson($response);
                            exit;
                        }
                        
                    }else{
                        $response['status'] = "faild";
                        $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Offer Id Error</div>';
                        echo $this->loadAjax()->DataToJson($response);
                        exit;
                    }
            }else{
                $response['status'] = "faild";
                $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                echo $this->loadAjax()->DataToJson($response);
                exit;
            }
        }
    }
    public function deleteProductFromCart()
    {
        session_start();
        if(isset($_POST['offer_id'],$_POST['action']) && $_POST['action'] = "deleteProductFromCart")
        {
            // preparing validation array
            $validationArray = array(
                                        
                                        "id_offer"=>array(
                                                         "value"=>$this->loadSecurity($_POST['offer_id'])->clear(),
                                                         "errorName"=>"Product Id",
                                                         "rules"=>"required|number"
                                                         )
                              );
            // load validation classs and pass validation data
            $dataValid = $this->loadValidation($validationArray)->formValidate();
            // check if the data is ok
            if(is_array($dataValid) && array_key_exists("success",$dataValid))
            {
                // get user id
                $user_id = $this->loadSession()->getSession("user_id");   
                if($user_id != NULL)
                {
                    $id_offer = (int)$dataValid['success']['id_offer'];
                    // get offer data
                    $offer = $this->loadModel("OfferModel")->retrieveAllData("WHERE `id` =? AND `status` =? AND `deleted` =?",array($id_offer,1,1));
                    if(is_array($offer))
                    {
                        $offer = array_shift($offer);
                        if(isset($_SESSION['cart'][$id_offer]))
                        { 
                            unset($_SESSION['cart'][$id_offer]);
                            $response['status'] = "success";
                            $response['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> success </strong>Your Cary Successfully Updated. </div>';
                            echo $this->loadAjax()->DataToJson($response);
                            exit;
                        }else{
                            $response['status'] = "faild";
                            $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Offer Id Error</div>';
                            echo $this->loadAjax()->DataToJson($response);
                            exit;
                        }
                        
                    }else{
                        $response['status'] = "faild";
                        $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Offer Id Error</div>';
                        echo $this->loadAjax()->DataToJson($response);
                        exit;
                    }
                }else{
                    $response['status'] = "faild";
                        $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> User Id Error</div>';
                    echo $this->loadAjax()->DataToJson($response);
                    exit;
                }
            }else{
                $response['status'] = "faild";
                $response['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                echo $this->loadAjax()->DataToJson($response);
                exit;
            }
        }
    }
    public function add_favorite_offer()
	{
	    session_start();
		if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "addFavoriteOffer")
		{
            // check user log in
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // preparing validation array
                $dataValid = array(
                                "id_offer"=>array(
                                                "value"=>$this->loadSecurity($_POST['id'])->clear(),
                                                "errorName"=>"Id Product",
                                                "rules"=>"required|number"
                                              )
                );
                // load Validation And Pass Vlidation Array
                $validationResult = $this->loadValidation($dataValid)->formValidate();
                // check if data is ok
                if(is_array($validationResult) && array_key_exists("success",$validationResult))
                {
                    // get user id 
                    $user_id = $this->loadSession()->getSession("user_id");
                    // check offer is not exists before
                    if($this->loadModel("UserFavoriteOfferModel")->retrieveAllData("WHERE `id_offer` = ? AND `id_user` = ?",array($validationResult['success']['id_offer'],$user_id)) == NULL)
                    {
                        // add time and id user to success array
                        $validationResult['success']['created'] = time();
                        $validationResult['success']['id_user'] = $user_id;
                        //var_dump($validationResult['success']);
                        //exit;
                        // add email
                        if(FALSE !== $this->loadModel("UserFavoriteOfferModel",$validationResult['success'])->add())
                        {
                            $dataView['status'] = 'success'; 
                            $dataView['message'] = '<div class="alert alert-success" role="alert"><strong></strong> Your List Successfully Updated. </div>';
                            echo $this->loadAjax()->DataToJson($dataView);
                            exit; 
                        }else{
                            $dataView['status'] = 'faild'; 
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><strong></strong> Please Try Again..</div>';
                            echo $this->loadAjax()->DataToJson($dataView);
                            exit;
                        }

                    }else{
                        $dataView['status'] = 'faild'; 
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><strong></strong> Product Already Exists On Your List Before .</div>';
                        echo $this->loadAjax()->DataToJson($dataView);
                        exit;
                    }
                }else{
                    $dataView['status'] = 'faild'; 
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><strong>Error : </strong>'.$validationResult.' .</div>';
                    echo $this->loadAjax()->DataToJson($dataView);
                    exit;
                }
            }else{
                $dataView['status'] = 'faild'; 
                $dataView['message'] = '<div class="alert alert-danger" role="alert"><strong>Error : </strong>Please Login For Add Products To Your Favorite List. </div>';
                echo $this->loadAjax()->DataToJson($dataView);
                exit;
            }
		}
	}
    
}
?>