<?php
class Service extends Controller{
    public function index()
	{

        /******** start header code ********/
		if($this->loadHelper("UserHelper")->check_user_login())
		{
			// get user id from session
			$user_id = $this->loadSession()->getSession("user_id");
			// get user data for header
			$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
			if($dataView['userData'] == NULL)

			{
				$this->redirect("error","index");
				exit();
			}
		}
        $dataView['current'] = "service";
		/******* end header code *******/

        //get all service data
        $dataView['services'] = $this->loadModel("ServiceModel")->retrieveAllData("WHERE `status` =? AND `deleted`=?",array(1,1));
        if(is_array($dataView['services']))
        {
            //get all Lang data
            foreach ($dataView['services'] as $key=>$value)
            {
                $dataView['servicesLang'][$key] = $this->loadModel("ServiceEnModel")->retriveDataById('id_service',$value['id']);
            }
        }
        // set page title
		$dataView['title'] = "Shatably | Services";
		 // global Template Config
        global $TEMPLATE_FRONT_END ;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH."service_view";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END,$dataView)->render();

	}
    
    public function view()
	{

        /******** start header code ********/
		if($this->loadHelper("UserHelper")->check_user_login())
		{
			// get user id from session
			$user_id = $this->loadSession()->getSession("user_id");
			// get user data for header
			$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
			if($dataView['userData'] == NULL)

			{
				$this->redirect("error","index");
				exit();
			}
		}
        $dataView['current'] = "service";
		/******* end header code *******/
        // get Service id from url
        $id = (int)$this->loadRoute()->getSegment(2);
        if($id == 0)
        {
            $this->redirect("error","index");
            exit();
        }
        //get service data
        $dataView['service'] = $this->loadModel("ServiceModel")->retriveDataById('id',$id);
        //check data is valid or not
        if($dataView['service'] == null)
        {
            $this->redirect("error","index");
            exit();
        }
        if(is_array($dataView['service']))
        {
            //get Servic Arabic Data and English Data
            $dataView['serviceLang'] = $this->loadModel("ServiceEnModel")->retriveDataById('id_service',$dataView['service']['id']);

        }

        // set page title
		$dataView['title'] = "Shatably | ".$dataView['serviceLang']['title'];
		 // global Template Config
        global $TEMPLATE_FRONT_END ;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH."service_show_selected";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END,$dataView)->render();

	}
    public function request()
	{
        ob_start();
        // get Service id from url
        $id = (int)$this->loadRoute()->getSegment(2);
        if($id == 0)
        {
            $this->redirect("error","index");
            exit();
        }
        /******** start header code ********/
		if($this->loadHelper("UserHelper")->check_user_login())
		{
			// get user id from session
			$user_id = $this->loadSession()->getSession("user_id");
			// get user data for header
			$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
			if($dataView['userData'] == NULL)

			{
				$this->redirect("error","index");
				exit();
			}
		}else{
		    $url = BASE_URL."service/request/".$id;
		    $this->loadSession(array("url"=>$url))->setSession();
            $this->redirect("login","index");
            exit();
        }
        $dataView['current'] = "service";
		/******* end header code *******/
        // get Service id from url
        $id = (int)$this->loadRoute()->getSegment(2);
        if($id == 0)
        {
            $this->redirect("error","index");
            exit();
        }
        //get service data
        $dataView['service'] = $this->loadModel("ServiceModel")->retriveDataById('id',$id);
        //check data is valid or not
        if($dataView['service'] == null)
        {
            $this->redirect("error","index");
            exit();
        }
        if(is_array($dataView['service']))
        {
            //get Servic Arabic Data and English Data
            $dataView['serviceLang'] = $this->loadModel("ServiceEnModel")->retriveDataById('id_service',$dataView['service']['id']);

        }
        
        if (isset($_POST['add'])) {
                                // preparing validation array
         $validationArray = array(
                                    "id_address" => array(
                                        "value" => $this->loadSecurity($_POST['address'])->clear(),
                                        "errorName" => "Address",
                                        "rules"=>"required|number"
                                    ),
                                    "note" => array(
                                        "value" => $this->loadSecurity($_POST['note'])->clear(),
                                        "errorName" => "Notes",
                                    ),

            );

            // load validation classs and pass validation data
            $dataValid = $this->loadValidation($validationArray)->formValidate();
            // check if the data is ok
            if (is_array($dataValid) && array_key_exists("success", $dataValid)) {

                // prepare data
                $dataValid['success']['id_customer'] = $user_id;
                $dataValid['success']['id_service'] = $id;
                $dataValid['success']['created_by'] = $user_id;
                $dataValid['success']['last_updated_by'] = $user_id;
                $dataValid['success']['created'] = time();

                $add = $this->loadModel("ServiceRequestModel", $dataValid['success'])->add();
                if (FALSE !== $add) {
                    $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Order Has Been Successfully Sent Please Wait...</div>';
                    header("Refresh: 2");
                } else {
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>Please Try Again</div>';
                }
            } else {
                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>' . $dataValid . '</div>';
            }
        }
        // get user addresses
        $dataView['addresses'] = $this->loadModel("UserAddressModel")->retrieveAllData("WHERE `id_user` =? AND `status` =? AND `deleted` =?", array($user_id, 1, 1));
        // get addresses data
        if (is_array($dataView['addresses'])) {
            foreach ($dataView['addresses'] as $key => $value) {
                $dataView['addresses_cities'][$key] = $this->loadModel("CityEnModel")->retriveDataById("id_city", $value['id_city']);
            }
        }
        
        // get all citites
        $dataView['cities'] = $this->loadModel("CityEnModel")->retrieveAllData("WHERE `status` =? AND `deleted` =? ORDER BY `name` DESC", array( 1, 1));
        
        // set page title
		$dataView['title'] = "Shatably | ".$dataView['serviceLang']['title'];
		 // global Template Config
        global $TEMPLATE_FRONT_END ;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH."service_request";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END,$dataView)->render();

	}
    
}
?>