<?php
class User extends Controller{
    public function index()

	{

        /******** start header code ********/
		if($this->loadHelper("UserHelper")->check_user_login())
		{
			// get user id from session
			$user_id = $this->loadSession()->getSession("user_id");
			// get user data for header
			$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
			if($dataView['userData'] == NULL)

			{
				$this->redirect("error","index");
				exit();
			}
		}else{
            $this->redirect("login","index");
            exit();
        }
        $dataView['current'] = "profile";
		/******* end header code *******/

        $dataView['total_orders'] = $this->loadModel("CustomerOrderModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `customer_order` WHERE `id_customer` =? AND `deleted` =?",array($user_id,1));
        $dataView['total_favorites'] = $this->loadModel("UserFavoriteOfferModel")->retrieveDataByQuery("SELECT COUNT(`id`) as `count` FROM `user_favorite_offer` WHERE `id_user` =? AND `deleted` =?",array($user_id,1));
        // set page title
		$dataView['title'] = "Shatably | User Profile";
		 // global Template Config
        global $TEMPLATE_FRONT_END ;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH."user_home";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END,$dataView)->render();

	}
    public function getAllOrders() {

        /*         * ****** start header code ******* */

        if ($this->loadHelper("UserHelper")->check_user_login()) {
            // get user id from session
            $user_id = $this->loadSession()->getSession("user_id");
            // get user data for header
            $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id", $user_id);
            if ($dataView['userData'] == NULL) {
                $this->redirect("error", "index");
                exit();
            }
        } else {
            $this->redirect("login", "index");
            exit();
        }

        $dataView['orders'] = $this->loadModel("CustomerOrderModel")->retrieveAllData("WHERE `id_customer` = ? AND `deleted` =?",array($user_id,1));
        //get order data
        if(is_array($dataView['orders']))
        {
            foreach ($dataView['orders'] as $key =>$value)
            {
                // get order status
                $oderLastStatus = $this->loadModel("TrackingOrderStatus")->retrieveAllData("WHERE `id_order` = ?AND `deleted` =? ORDER BY `id` DESC LIMIT 1",array($value['id'],1));
                $dataView['orderStatusLang'][$key]=$this->loadModel("OrderStatusEnModel")->retriveDataById('id_order_status',$oderLastStatus[0]['id_order_status']);
            }
        }
        // set page title
        $dataView['title'] = "Shatably | User Orders";
        // global Template Config
        global $TEMPLATE_FRONT_END;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH . "user_orders_getall";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END, $dataView)->render();
    }
    public function show_selected_order() {

        /*         * ****** start header code ******* */

        if ($this->loadHelper("UserHelper")->check_user_login()) {
            // get user id from session
            $user_id = $this->loadSession()->getSession("user_id");
            // get user data for header
            $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id", $user_id);
            if ($dataView['userData'] == NULL) {
                $this->redirect("error", "index");
                exit();
            }
        } else {
            $this->redirect("login", "index");
            exit();
        }
        /** ****** End header code ******* */
        
        $id = (int) $this->loadRoute()->getSegment(2);
        if($id == 0)
        {
            $this->redirect("error","index");
            exit();
        }

        $dataView['order'] = $this->loadModel("CustomerOrderModel")->retrieveAllData("WHERE `id` = ? AND `id_customer` = ? AND `deleted` =?",array($id,$user_id,1));
        //get order data
        if(!is_array($dataView['order']))
        {
            $this->redirect("error","index");
            exit();
        }
        $dataView['order'] = array_shift($dataView['order']);
        // get order address
        $dataView['userAddress'] = $this->loadModel("UserAddressModel")->retriveDataById('id',$dataView['order']['id_address']);
        $dataView['paymentWay'] = $this->loadModel("PaymentWayEnModel")->retriveDataById('id_payment',$dataView['order']['id_payment_way']);
        if($dataView['order']['delivery_time'] == 2)
        {
            $dataView['deliveryDate'] = $this->loadModel("OrderDeliveryTimeModel")->retriveDataById('id_order',$dataView['order']['id']);
        }
        //get city
        $dataView['city'] = $this->loadModel("CityEnModel")->retriveDataById('id_city',$dataView['userAddress']['id_city']);
        //get order details
        $dataView['orderDetails'] = $this->loadModel("CustomerOrderModelDetails")->retrieveAllData('WHERE `id_order` =? AND `deleted`=?',array($id,1));
        if(is_array($dataView['orderDetails']))
        {
            foreach ($dataView['orderDetails'] as $key =>$value)
            {
                //get product Lang Data
                $dataView['productLang'][$key] = $this->loadModel("OfferEnModel")->retriveDataById('id_offer',$value['id_product']);
            }
        }
        // get order status
        $orderLastStatus = $this->loadModel("TrackingOrderStatus")->retrieveAllData("WHERE `id_order` = ? AND `deleted` =? ORDER BY `id` DESC LIMIT 1",array($id,1));
        $dataView['orderStatusLang'] = $this->loadModel("OrderStatusEnModel")->retriveDataById('id_order_status',$orderLastStatus[0]['id_order_status']);
        
        // set page title
        $dataView['title'] = "Shatably | Customer Orders";
        // global Template Config
        global $TEMPLATE_FRONT_END;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH . "user_orders_show_selected";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END, $dataView)->render();
    }
    public function getAllServices() {

        /*         * ****** start header code ******* */

        if ($this->loadHelper("UserHelper")->check_user_login()) {
            // get user id from session
            $user_id = $this->loadSession()->getSession("user_id");
            // get user data for header
            $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id", $user_id);
            if ($dataView['userData'] == NULL) {
                $this->redirect("error", "index");
                exit();
            }
        } else {
            $this->redirect("login", "index");
            exit();
        }

        $dataView['orders'] = $this->loadModel("ServiceRequestModel")->retrieveAllData("WHERE `id_customer` = ? AND `deleted` =?",array($user_id,1));
        //get order data
        if(is_array($dataView['orders']))
        {
            foreach ($dataView['orders'] as $key =>$value)
            {
                // get service Lang
                $dataView['servicesLang'][$key] = $this->loadModel("ServiceEnModel")->retriveDataById('id_service',$value['id_service']);
                $dataView['userAddress'][$key] = $this->loadModel("UserAddressModel")->retriveDataById('id',$value['id_address']);
                $dataView['city'][$key] = $this->loadModel("CityEnModel")->retriveDataById('id_city',$dataView['userAddress'][$key]['id_city']);
            }
        }
        // set page title
        $dataView['title'] = "Shatably | Customer Services Requests";
        // global Template Config
        global $TEMPLATE_FRONT_END;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH . "user_services_getall";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END, $dataView)->render();
    }
    public function favorite_offers() 
    {

        /*  * ****** start header code ******* */

        if ($this->loadHelper("UserHelper")->check_user_login()) {
            // get user id from session
            $user_id = $this->loadSession()->getSession("user_id");
            // get user data for header
            $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id", $user_id);
            if ($dataView['userData'] == NULL) {
                $this->redirect("error", "index");
                exit();
            }
        } else {
            $this->redirect("login", "index");
            exit();
        }



        /*         * ***** end header code ****** */
        // get user offers
        $dataView['favorites'] = $this->loadModel("UserFavoriteOfferModel")->retrieveAllData("WHERE `id_user` =?  AND `status` =? AND `deleted` =?", array($user_id, 1, 1));
        if (is_array($dataView['favorites'])) {
            foreach ($dataView['favorites'] as $key => $value) {
                $dataView['offers'][$key] = $this->loadModel("OfferModel")->retriveDataById("id", $value['id_offer']);
                $dataView['offersLang'][$key] = $this->loadModel("OfferEnModel")->retriveDataById("id_offer", $dataView['offers'][$key]['id']);
            }
        }
        // set page title
        $dataView['title'] = "Favorite Offers";
        // global Template Config
        global $TEMPLATE_FRONT_END;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH . "user_favorites";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END, $dataView)->render();
    }
    public function address_add() 
    {

        /*  * ****** start header code ******* */

        if ($this->loadHelper("UserHelper")->check_user_login()) {
            // get user id from session
            $user_id = $this->loadSession()->getSession("user_id");
            // get user data for header
            $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id", $user_id);
            if ($dataView['userData'] == NULL) {
                $this->redirect("error", "index");
                exit();
            }
        } else {
            $this->redirect("login", "index");
            exit();
        }



        /*         * ***** end header code ****** */
        
        if (isset($_POST['addAddress'])) {
                                // preparing validation array
         $validationArray = array(

                                    "id_city" => array(
                                        "value" => $this->loadSecurity($_POST['id_city'])->clear(),
                                        "errorName" => "City",
                                        "rules" => "required|number"
                                    ),
                                    "region_name" => array(
                                        "value" => $this->loadSecurity($_POST['region_name'])->clear(),
                                        "errorName" => "Region",
                                        "rules" => "required|min-length[3]"
                                    ),
                                    "street" => array(
                                        "value" => $this->loadSecurity($_POST['street'])->clear(),
                                        "errorName" => "Street Name",
                                        "rules" => "required"
                                    ),
                                    "building_number" => array(
                                        "value" => $this->loadSecurity($_POST['building_number'])->clear(),
                                        "errorName" => "Building Number",
                                    ),
                                    "floar_number" => array(
                                        "value" => $this->loadSecurity($_POST['floar_number'])->clear(),
                                        "errorName" => "floor Number",
                                        "rules" => "required"
                                    ),
            );

            // load validation classs and pass validation data
            $dataValid = $this->loadValidation($validationArray)->formValidate();
            // check if the data is ok
            if (is_array($dataValid) && array_key_exists("success", $dataValid)) {

                // prepare data
                $dataValid['success']['id_user'] = $user_id;
                $dataValid['success']['created'] = time();

                $add = $this->loadModel("UserAddressModel", $dataValid['success'])->add();
                if (FALSE !== $add) {
                    $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Address Successfully Added .</div>';
                    header("Refresh: 2");
                } else {
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Please Try Again</div>';
                }
            } else {
                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>' . $dataValid . '</div>';
            }
        }
        // get all citites
        $dataView['cities'] = $this->loadModel("CityArModel")->retrieveAllData("WHERE `status` =? AND `deleted` =? ORDER BY `name` DESC", array( 1, 1));
        // set page title
        $dataView['title'] = "Shatably | Add Address";
        // global Template Config
        global $TEMPLATE_FRONT_END;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH . "user_addresses_add";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END, $dataView)->render();
    }
    public function address_getall() 
    {

        /*  * ****** start header code ******* */

        if ($this->loadHelper("UserHelper")->check_user_login()) {
            // get user id from session
            $user_id = $this->loadSession()->getSession("user_id");
            // get user data for header
            $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id", $user_id);
            if ($dataView['userData'] == NULL) {
                $this->redirect("error", "index");
                exit();
            }
        } else {
            $this->redirect("login", "index");
            exit();
        }



        /*         * ***** end header code ****** */
        
        // get user addresses
        $dataView['addresses'] = $this->loadModel("UserAddressModel")->retrieveAllData("WHERE `id_user` =? AND `status` =? AND `deleted` =?", array($user_id, 1, 1));
        // get addresses data
        if (is_array($dataView['addresses'])) {
            foreach ($dataView['addresses'] as $key => $value) {
                $dataView['addresses_cities'][$key] = $this->loadModel("CityEnModel")->retriveDataById("id_city", $value['id_city']);
            }
        }

        // set page title
        $dataView['title'] = "Shatably | Customer Addresses";
        // global Template Config
        global $TEMPLATE_FRONT_END;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH . "user_addresses";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END, $dataView)->render();
    }
    public function profile_edit() 
    {
        ob_start();
        /*  * ****** start header code ******* */

        if ($this->loadHelper("UserHelper")->check_user_login()) {
            // get user id from session
            $user_id = $this->loadSession()->getSession("user_id");
            // get user data for header
            $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id", $user_id);
            if ($dataView['userData'] == NULL) {
                $this->redirect("error", "index");
                exit();
            }
        } else {
            $this->redirect("login", "index");
            exit();
        }



        /*         * ***** end header code ****** */
        
        //start Edit profile
			if(isset($_POST['edit']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['name'])->clear(),
                                                             "errorName"=>"Name",
                                                             "rules"=>"required|min-length[4]"
                                                          ),
                                            "mail"=>array(
                                                             "value"=>$this->loadSecurity($_POST['mail'])->clear(),
                                                             "errorName"=>"Mail",
                                                             "rules"=>"required|email"
                                                          ),
                                            "phone"=>array(
                                                             "value"=>$this->loadSecurity($_POST['phone'])->clear(),
                                                             "errorName"=>"Phone",
                                                             "rules"=>"required"
                                                          ),
                                            "gender"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['gender'])->clear(),
                                                                 "errorName"=>"Gender",
                                                                 "rules"=>"required|number"
                                                              ),

                                            
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                { 
                     //check if mail exists before
                    if(TRUE !== $this->loadModel("UserModel")->CheckExists("WHERE `mail` =? AND `id`!=? AND `deleted`=?",array($dataValid['success']['mail'],$user_id,1)))
                    {
                        //check if phone exists before
                        if(TRUE !== $this->loadModel("UserModel")->CheckExists("WHERE `phone` =?  AND `id`!=? AND `deleted`=?",array($dataValid['success']['phone'],$user_id,1)))
                        {

                            if(FALSE !== $this->loadModel("UserModel",$dataValid['success'])->updateData('id',$user_id))
                            {
                                $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Successfully Updated .</div>';
                                header("Refresh: 2");
                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>Please Try Again </div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Phone Already Exists Before .</div>';
                        }
                    }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Email Already Exists Before .</div>';
                    }
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
        // set page title
        $dataView['title'] = "Shatably | Update User Profile";
        // global Template Config
        global $TEMPLATE_FRONT_END;
        // set content
        $TEMPLATE_FRONT_END['files']['content'] = FRONT_END_CONTROL_PATH . "user_profile";
        // load template
        $this->loadTemplate($TEMPLATE_FRONT_END, $dataView)->render();
    }
    public function deleteFavoriteOffer()
    {
        session_start();
        if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
        {
            //ger service id
            $id = (int)$_POST['id'];
            if($id == 0)
            {
                $this->redirect("error","index");
                exit;
            }else{
                $user_id = $this->loadSession()->getSession("user_id");

                if(FALSE !== $this->loadModel("UserFavoriteOfferModel",array("deleted"=>2))->updateByCondition(" WHERE `id` =? AND `id_user` =?",array($id,$user_id)))
                {
                    echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                    exit;
                }else{
                    echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                    exit;
                }
            }
         }
     }
    public function deleteAddress()
    {
        session_start();
        if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
        {
            //ger service id
            $id = (int)$_POST['id'];
            if($id == 0)
            {
                $this->redirect("error","index");
                exit;
            }else{
                $user_id = $this->loadSession()->getSession("user_id");

                if(FALSE !== $this->loadModel("UserAddressModel",array("deleted"=>2))->updateByCondition(" WHERE `id` =? AND `id_user` =?",array($id,$user_id)))
                {
                    echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                    exit;
                }else{
                    echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                    exit;
                }
            }
         }
     }
     public function update_profile_image()
        {
        session_start();
            //get id
            $id = (int)$this->loadSession()->getSession("user_id");;
             if($id == 0)
            {
                $this->redirect("Errors","index");
                exit;
            }else{
                    $upload = $this->loadUpload("image_name")->do_upload();
                   // check if there is error on image
                   if(array_key_exists("uploadError",$upload))
                   {
                       echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                        exit;

                   }else{
                       $dataModel['photo'] = $upload['uploaded'][0];
                       if(false !== $this->loadModel("UserModel",$dataModel)->updateData("id", $id))
                       {
                           echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['photo']));
                            exit; 
                       }else{
                          echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                          exit;
                       }
                   }
                }  
        }
        
        public function update_password()
        {
        session_start();
            //get id
            $id = (int)$this->loadSession()->getSession("user_id");
             if($id == 0)
            {
                $this->redirect("Errors","index");
                exit;
            }else{
                // preparing validation array
                $validationArray = array(
                                        "old_password"=>array(
                                                             "value"=>$this->loadSecurity($_POST['old_password'])->clear(),
                                                             "errorName"=>"Current Password",
                                                             "rules"=>"required|min-length[6]"
                                                          ),
                                            "password"=>array(
                                                             "value"=>$this->loadSecurity($_POST['password'])->clear(),
                                                             "errorName"=>"New Password",
                                                             "rules"=>"required|min-length[6]|sha1_md5"
                                                          ),
                                            "re_password"=>array(
                                                             "value"=>$this->loadSecurity(sha1(md5($_POST['repassword'])))->clear(),
                                                             "errorName"=>"Re Password",
                                                             "rules"=>"required|match[password]"
                                                          )
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    // check old password
                    $oldPass = $this->loadModel("UserModel")->retrieveAllData("WHERE `id`=? AND `password`=? AND `status`=? AND `deleted`=?",array($id,sha1(md5($dataValid['success']['old_password'])),1,1));
                    if(is_array($oldPass))
                    {
                        // unset old password from success array
                        unset($dataValid['success']['old_password']);
                        unset($dataValid['success']['re_password']);
                        if(false !== $this->loadModel("UserModel",$dataValid['success'])->updateData("id",$id))
                        {
                            $response['status'] = "success";
                            $response['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Password Successfully Updated . </div>';
                            echo $this->loadAjax()->DataToJson($response);
                            exit;
                        }else{
                            $response['status'] = "faild";
                            $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Please Try Again .</div>';
                            echo $this->loadAjax()->DataToJson($response);
                            exit;
                        }
                    }else{
                        $response['status'] = "faild";
                        $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Wrong Current Password</div>';
                        echo $this->loadAjax()->DataToJson($response);
                        exit;
                    }
                }else{
                    $response['status'] = "faild";
                    $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                    echo $this->loadAjax()->DataToJson($response);
                    exit;
                }
            }  
        }

    
}
?>